-- This file has been generated by Dungeon Editor 2.2.4

-- TODO: place your custom monster definitions here

defineObject{
	name = "sx_gelatinous_cube",
	baseObject = "base_monster",
	components = {
		{
			class = "Model",
			model = "mod_assets/models/sx_gelatinous_cube.fbx",
			storeSourceData = true,
		},
		{
			class = "Animation",
			animations = {
				idle = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				moveForward = "mod_assets/animations/sx_gelatinous_cube_forward.fbx",
				turnLeft = "mod_assets/animations/sx_gelatinous_cube_turnleft.fbx",
				turnRight = "mod_assets/animations/sx_gelatinous_cube_turnright.fbx",
				attack = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				getHitFrontLeft = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				getHitFrontRight = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				getHitBack = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				getHitLeft = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				getHitRight = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
				fall = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
			},
			currentLevelOnly = true,
		},
		{
			class = "Monster",
			meshName = "gelatinous_cube_mesh",
			hitSound = "slime_hit",
			dieSound = "slime_die",
			hitEffect = "hit_slime",
			capsuleHeight = 1.5,
			capsuleRadius = 3,
			collisionRadius = 3,
			health = 650,
			evasion = 0,
			exp = 1200,
			swarm = true,
			immunities = { "sleep", "blinded", "backstab", "assassination" },
			resistances = {
				["fire"] = "resist",
				["cold"] = "resist",
				["poison"] = "immune",
				["shock"] = "resist"
			},
		},
		{
			class = "SwarmBrain",
			name = "brain",
			sight = 8,
		},
		{
			class = "MonsterMove",
			name = "move",
			sound = "slime_walk",
			cooldown = 2,
		},
		{
			class = "MonsterTurn",
			name = "turn",
			sound = "slime_walk",
		},
		{
			class = "Light",
			parentNode = "hip",
			color = vec(2.39, 2.32, 1.81),
			brightness = 3,
			range = 5,
			fillLight = true,
		},
		{
			class = "MonsterAttack",
			name = "basicAttack",
			cooldown = 0,
			animation = "attack",
			sound = "slime_attack",
			causeCondition = "diseased",  -- seems to do nothing
			conditionChance = 30,         -- seems to do nothing
			onAttack = function(self)
				for i=1,4 do
					local champion = party.party:getChampion(i)
					champion:damage(math.random(2,5), "pure")
				end
				return false
			end,
		},
	},
}

defineAnimationEvent{
	animation = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
	event = "attack",
	frame = 2,
}

defineAnimationEvent{
	animation = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
	event = "attack",
	frame = 10,
}

defineAnimationEvent{
	animation = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
	event = "attack",
	frame = 18,
}

defineAnimationEvent{
	animation = "mod_assets/animations/sx_gelatinous_cube_idle.fbx",
	event = "attack",
	frame = 26,
}

defineMaterial{
	name = "sx_gelatinous_cube",
	diffuseMap = "assets/textures/monsters/green_slime_dif.tga",
	specularMap = "assets/textures/common/white.tga",
	normalMap = "assets/textures/monsters/green_slime_normal.tga",
	shadeTex = "assets/textures/env/healing_crystal_shadetex.tga",
	doubleSided = true,
	lighting = false,
	alphaTest = false,
	blendMode = "Additive",
	textureAddressMode = "Wrap",
	glossiness = 0,
	depthBias = 0,
	shader = "crystal",
	shadeTexAngle = 0,
	crystalIntensity = 0.4,
	onUpdate = function(self, time)
		self:setParam("shadeTexAngle", time*0.8)
	end,
}
